@echo off

rem -----------------------------------------
rem The following are required for runnig ant
rem -----------------------------------------
set oldpath=%CLASSPATH%
set JAVA_HOME=.\..\tools\java\jre
rem set JAVA_HOME=C:\IBM\WebSphere\AppServer\java\jre
set ANT_HOME=.\..\tools\ant
set TOOLS_HOME=.\..\tools\maximo
set MAXIMO_HOME=.\..\applications\maximo

rem ------------------------------------------------------------
set BUILD_DIR=.\default
set EAR_FILENAME=maximo.ear

set MAXIMO_PROPERTIES=maximo.properties

set CLASSPATH=.;%MAXIMO_HOME%\businessobjects\classes;%MAXIMO_HOME%\lib\jdom.jar;%TOOLS_HOME%;%TOOLS_HOME%\classes
%JAVA_HOME%\bin\java  -classpath  %CLASSPATH% psdi.tools.MergeWSDefinition -k. -t.\..\applications\maximo\meaweb\webmodule\WEB-INF

%JAVA_HOME%\bin\java  -classpath %CLASSPATH%  psdi.tools.MaximoBuildEarTask -k.

IF ERRORLEVEL 1 GOTO resetclasspath

set ANT_OPTS=%ANT_OPTS% -Xmx1024M

call %ANT_HOME%\bin\ant  -buildfile .\buildmaximoear-build.xml -Dmaximo.builddir=%BUILD_DIR%  -Dmaximo.basedir=.\..\applications\maximo -Dmaximo.earfile=%EAR_FILENAME% -Dmaximo.properties=%MAXIMO_PROPERTIES% -Dmaximo.axis2=lib/xmlbeans-3.1.0.jar -Dmaximo.xmlbeans=lib/axis2.jar -Dmaximo.jaxen=lib/jaxen-1.1-beta-8.jar %1

:resetclasspath
set CLASSPATH=%oldpath%
:End

